//---- Trunk of car & Gas Cap
//
//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

#declare Trunk =
object {
  union { 
    difference {
      cylinder { z, -z, 1 scale <95, 95, 30> translate <-56, -35, 0> }
      plane { y, 28 }
      plane { x, -67 inverse }
      plane { x, -110 }
      object { Cylinder_Y scale <24, 1, 24> translate x*-94 }
      box { -1, 1 scale <12, 18, 24> translate <-106, 40, 0> }
    }
    difference {
      cylinder { z, -z, 1 scale <89.5, 89.5, 30> translate <-61.5, -35, 0> }
      plane { y,   28 }
      plane { x,  -67 inverse }
      plane { x, -120 }
    }
  }
  texture { BodyTexture }
  bounded_by { box { -1, 1 scale <30, 25, 32> translate <-94, 40, 0> } }
}


//---Gas Cap
#declare GasCap =
object {
  union {
    cylinder { y, -y, 1 scale <4, 1,   4> translate <-75, 61,   21.5> }
    cylinder { y, -y, 1 scale <3, 2.5, 3> translate <-75, 57.5, 21.5> }
    sphere { 0, 1 scale <3.5, 1, 3.5> translate <-25, 62, 21.5> }
  }
  texture { CromeTexture }
  bounded_by { box { -1, 1 scale 5 translate <-75, 58.8, 21.5> } }
}